#include "conn.hh"
#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/entry.h>
#include <string>
// #include <sigc++/signal.h>
#include <iostream>

class ConnTest :
	public igs::Conn
{
	Gtk::Window win;
	Gtk::Entry ent;

	void process_line()
	{
		std::cout << line_buffer << std::endl;
	}

	void enter_line()
	{
		std::string d = ent.get_text();
		ent.set_text("");
		std::cout << d << std::endl;
		send_line(d);
	}
public:
	ConnTest()
	{
		win.add(ent);
		open_conn("telnet igs.joyjoy.net 6969");
		ent.signal_activate().connect(SigC::slot(* this, & ConnTest::enter_line));
	}

	Gtk::Window & get_win()
	{
		return win;
	}
};


int main(int argc, char * argv[])
{
	Gtk::Main m(& argc, & argv);

	ConnTest ct;
	ct.get_win().show_all();
	Gtk::Main::run(ct.get_win());
	return 0;
}
