/* ccgo: prop_node.cc
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "prop_node.hh"

using namespace go;
using namespace std;

PropNode::PropNode(const sgf::Node & n) :
	sgf::Node(n)
{
}

PropNode::PropNode(const sgf::Tree & t) :
	sgf::Node(t.get_node_list()[0])
{
	PropNode * p = this;
	for (vector<sgf::Node>::const_iterator i = t.get_node_list().begin() + 1; i  != t.get_node_list().end(); i ++) {
		PropNode * pp = new PropNode(* i);
		p->set_next(pp);
		p = pp;
	}
	for (vector<sgf::Tree>::const_iterator i = t.get_sub_trees().begin(); i  != t.get_sub_trees().end(); i ++) {
		p->set_next(new PropNode(* i));
	}
}

void PropNode::dump(ostream & o) const
{
	o << '(';
	sgf::Node::save(o);
	for (unsigned i = 0; i < get_link_size(); ++ i) {
		PropNode * p = dynamic_cast<PropNode *>(get_next(i));
		if (p != NULL) p->dump(o);
	}
	o << ')';
}

void PropNode::set_proper(const Game & g, Proper * p)
{
	if (p != NULL) p->build(g, * this);
	ProperNode::set_proper(g, p);
}
